#pragma once
#include <windows.h>
#include <stdlib.h>

class Color
{
public:
	Color( unsigned long rgbcolor );
	Color( int r, int g, int b );

	int red();
	int blue();
	int green();

	COLORREF colorref();

	unsigned long c;
};

class Font
{
public:
	Font();
	Font( const Font & f );
	Font(int height, char * facename = "Courier", bool fixedwidth = true);
	~Font();
	Font & operator= (const Font & f);

	bool GotRequestedFont();

	HFONT GetFont();

protected:
	bool TrySetFont( int height, bool fixedwidth, char* facename );
	void CopyFont( const Font & f );
	void KillFont();
	HFONT font;
	int * font_ref;
	bool gotrequestedfont;
};



class Bitmap
{
public:
	Bitmap(void);
	Bitmap(int width, int height);
	Bitmap( const Bitmap & b );
	~Bitmap(void);
	Bitmap & operator=( const Bitmap & b );

	int getWidth();
	int getHeight();
	HDC DC();

	unsigned long * getBits();


	void resize( int w, int h, bool preserve=false, bool scale=false);
	void cls( Color fillcolor );

	void clearrect( int x1, int x2, int y1, int y2, Color fillcolor );

	void pset(int x, int y, Color c);
	Color point(int x, int y);


	void hline( int x1, int x2, int y, Color linecolor );
	void vline( int x, int y1, int y2, Color linecolor );

	void line( int x1, int y1, int x2, int y2, Color linecolor );


	void SetTextcolor( Color textcolor );
	void SetFont( Font & f );
	void RenderText( int x, int y, const char * text, bool rightalign=false);
	void RenderCenteredText( int x, int y, const char * text );
	void RenderTextBlock( int x, int y, int width, int height, const char * text, bool wordbreak=false);

	void MakeLayeredAlpha();

protected:
	void ConstructBitmap(int w, int h);
	void DestroyBitmap( HDC hKillDC, HBITMAP hKillBitmap);

	int wid, hei;
	HDC hDC;
	HBITMAP hBmp;
	unsigned long * bmpbits;
	Font curfont;
};
