
#include <vector>

class Matrix4
{
public:
	float M[4][4];
	Matrix4()
	{
		int i,j;
		for(i=0;i<4;i++)
		{
			for(j=0;j<4;j++)
			{
				if(i==j) M[i][j] = 1.0f; else M[i][j] = 0.0f;
			}
		}
	}
	Matrix4(const Matrix4& m2)
	{
		int i,j;
		for(i=0;i<4;i++)
		{
			for(j=0;j<4;j++)
			{
				M[i][j] = m2.M[i][j];
			}
		}
	}


	Matrix4 & operator*=(const Matrix4 & m2)
	{
		int i,j;
		float row[4];
		for(i=0;i<4;i++)
		{
			for(j=0;j<4;j++) row[j] = M[i][j];
			for(j=0;j<4;j++)
			{
				M[i][j] = row[0]*m2.M[0][j] + row[1]*m2.M[1][j] + row[2]*m2.M[2][j] + row[3]*m2.M[3][j];
			}
		}
	}
	Matrix4 & operator*(const Matrix4 & m2) const
	{
		Matrix4 newmtx = *this;
		return newmtx *= m2;
	}


	template<typename VtxFormat>
	void TransformInPlace(VtxFormat & vtx)
	{
		float x,y,z,h;
		x = vtx.x;
		y = vtx.y;
		z = vtx.z;

		h =      M[0][3]*x + M[1][3]*y + M[2][3]*z + M[3][3];
		vtx.x = (M[0][0]*x + M[1][0]*y + M[2][0]*z + M[3][0])/h;
		vtx.y = (M[0][1]*x + M[1][1]*y + M[2][1]*z + M[3][1])/h;
		vtx.z = (M[0][2]*x + M[1][2]*y + M[2][2]*z + M[3][2])/h;
	}

	template<typename VtxFormat>
	VtxFormat& Transform(VtxFormat & src)
	{
		VtxFormat newvtx = src;
		TransformInPlace(newvtx);
		return newvtx;
	}
};


class Transform
{




};